Index: tests/example_scripts/python/Makefile.am
===================================================================
--- tests/example_scripts/python/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/python/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,99 @@
+#
+# example_scripts/python
+#
+
+.PHONY: clean-local
+
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+PYTHON_ENV = PYTHONPATH=$(abs_top_builddir)/swig/python:$(abs_top_builddir)/swig/python/.libs:$(abs_top_builddir)/tests
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(PYTHON_ENV) $(TEST_ENV)
+
+all: run_attr run_id run_id2 run_id3 run_prove
+
+clean:
+	@rm -f *.pem *.xml pfile
+
+setup:
+	@$(MY_ENV) ./setup.sh 1>/dev/null 2>&1 
+
+run_attr: 
+	@echo "---running (python) attr script"
+	@make clean
+	@make setup
+	@(rc=`$(MY_ENV) ./abac_attr.py IceCream_ID.pem IceCream_private.pem IceCream_attr.xml Chocolate_ID.pem |grep success` ; \
+	if [ -z "$$rc" ]; then \
+   	  echo "BAD:example_scripts/python/abac_attr.py:using libabac to create principal/attrs and make a simple query"; \
+	else \
+   	  echo "GOOD:example_scripts/python/abac_attr.py:using libabac to create principal/attrs and make a simple query"; \
+	fi)
+
+run_id: 
+	@echo "---running (python) id script"
+	@make clean
+	@make setup
+	@(rc=`$(MY_ENV) ./abac_keyid.py IceCream_ID.pem | grep okay` ; \
+	if [ -z "$$rc" ]; then \
+   	  echo "BAD:example_scripts/python/abac_keyid.py:using libabac to extract principal"; \
+	else \
+   	  echo "GOOD:example_scripts/python/abac_keyid.py:using libabac to extract principal"; \
+	fi)
+
+
+run_id2: 
+	@echo "---running (python) id2 script, expected failure"
+	@make clean
+	@make setup
+	@(rc=`$(MY_ENV) ./abac_keyid.py IceCream_private.pem  | grep okay` ; \
+	if [ -z "$$rc" ]; then \
+   	  echo "GOOD:example_scripts/python/abac_keyid.py:supplied with just a privkey"; \
+	else \
+   	  echo "BAD:example_scripts/python/abac_keyid.py:supplied with just a privkey, should fail"; \
+	fi)
+
+
+run_id3: 
+	@echo "---running (python) id3 script"
+	@make clean
+	@make setup
+	@(rc=`$(MY_ENV) ./abac_keyid2.py IceCream_ID.pem IceCream_private.pem | grep okay` ; \
+	if [ -z "$$rc" ]; then \
+   	  echo "BAD:example_scripts/python/abac_keyid.py:supplied both id and privkey pem files"; \
+	else \
+   	  echo "GOOD:example_scripts/python/abac_keyid.py:supplied with id and privkey pem files"; \
+	fi)
+
+run_prove:
+	@echo "---running (python) prover script"
+	@make clean
+	@make setup
+	@$(MY_ENV) ./abac_attr.py IceCream_ID.pem IceCream_private.pem IceCream_attr.xml Chocolate_ID.pem 1>/dev/null 2>&1
+	@(rc=`$(MY_ENV) ./run_prover| grep success` ; \
+	if [ -z "$$rc" ]; then \
+   	  echo "BAD:example_scripts/python/abac_prover.py:trying out libabac python api to make a prover"; \
+	else \
+   	  echo "GOOD:example_scripts/python/abac_prover.py:trying out libabac python api to make a prover"; \
+	fi)
+
+#this needed to be run by hand (input dumdum twice)...
+#echo '---running (python) encrypted key attr script'
+#./run_e_prover 1> e_prover.log 2>& 1
+#result=`grep success e_prover.log 2>/dev/null |wc -l`
+#if [ "$result" = "2" ]; then
+#   echo "   PASSED"
+#else
+#   echo "   ERROR"
+#fi
+#run_e_attr: 
+#	make clean
+#	rm -rf e_attr.log pfile
+#	echo "dumdum" > pfile
+#	openssl genrsa -des3 -out Soda_private.pem -passout file:pfile
+#	creddy --generate --cn Soda --key Soda_private.pem --p=pfile
+#	creddy --generate --cn Cream
+#	./abac_e_attr.py Soda_ID.pem Soda_private.pem Soda_attr.xml pfile Cream_ID.pem 1>e_attr.log 2>&1
+
Index: tests/example_scripts/python/run_e_prover
===================================================================
--- tests/example_scripts/python/run_e_prover	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/example_scripts/python/run_e_prover	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,3 +1,5 @@
 #!/bin/sh
+
+. ${TESTDIR}/test_util.sh
 
 keystore=`pwd`
@@ -8,11 +10,11 @@
 
 echo "make a id credential with encrypted private key"
-creddy --generate --cn Soda --key Soda_eprivate.pem
+$eloc/creddy --generate --cn Soda --key Soda_eprivate.pem
 
 echo "make a generic  id credential"
-creddy --generate --cn Slush 
+$eloc/creddy --generate --cn Slush 
 
 #principal
-creddy --generate --cn Cream
+$eloc/creddy --generate --cn Cream
 
 echo "make an attribute with id with encrypted private key"
Index: tests/example_scripts/python/run_prover
===================================================================
--- tests/example_scripts/python/run_prover	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/example_scripts/python/run_prover	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,7 +1,9 @@
 #!/bin/sh
 
+. ${TESTDIR}/test_util.sh
+
 keystore=`pwd`
-pID=`creddy --keyid --cert ${keystore}/IceCream_ID.pem`
-cID=`creddy --keyid --cert ${keystore}/Chocolate_ID.pem`
+pID=`$eloc/creddy --keyid --cert ${keystore}/IceCream_ID.pem`
+cID=`$eloc/creddy --keyid --cert ${keystore}/Chocolate_ID.pem`
 
 role="${pID}.delicious"
Index: tests/example_scripts/python/setup.sh
===================================================================
--- tests/example_scripts/python/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/python/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,10 @@
+#!/bin/sh
+# setup.sh
+
+. ${TESTDIR}/test_util.sh
+
+$eloc/creddy --generate --cn IceCream
+$eloc/creddy --generate --cn Chocolate
+
+
+
Index: tests/example_scripts/wiki/Makefile.am
===================================================================
--- tests/example_scripts/wiki/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/wiki/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,127 @@
+#
+# example_scripts/wiki
+#
+
+.PHONY: runcheck clean-local
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+PYTHON_ENV = PYTHONPATH=$(abs_top_builddir)/swig/python:$(abs_top_builddir)/swig/python/.libs:$(abs_top_builddir)/tests
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(PYTHON_ENV) $(TEST_ENV)
+
+
+FIRST=id1
+REST=id2 id3 id4 id5 attr1 attr2 ctxtQuery1 ctxtQuery2
+
+## need to enforce a specific order,
+all: $(FIRST) $(REST)
+
+id1: id1.py
+	@make clean
+	@echo "---running (wiki) id1.py script"
+	@(rc=`$(MY_ENV) ./id1.py |wc -c`; \
+	if [ $$rc -eq 41 ] ; then \
+	  echo "GOOD:example_scripts/wiki/id.py:making principal"; \
+	else \
+	  echo "BAD:example_scripts/wiki/id.py:making principal"; \
+	fi)
+
+gen_newguy: newguy.sh
+	@$(MY_ENV) ./newguy.sh 1>/dev/null 2>&1
+
+id2: id2.py
+	make gen_newguy
+	@echo "---running (wiki) id2.py script"
+	@(rc=`$(MY_ENV) ./id2.py |wc -c` ; \
+	if [ $$rc -eq 82 ]; then \
+	  echo "GOOD:example_scripts/wiki/id2.py:making principal and chunk"; \
+	else \
+	  echo "BAD:example_scripts/wiki/id2.py:making principal and chunk"; \
+	fi)
+
+id3: id3.py
+	@make clean
+	@echo "---running (wiki) id3.py script"
+	@(rc=`$(MY_ENV) ./id3.py |wc -c` ; \
+	if [ $$rc -eq 123 ]; then \
+	  echo "GOOD:example_scripts/wiki/id3.py:making principal and chunk"; \
+	else \
+	  echo "BAD:example_scripts/wiki/id3.py:making principal and chunk"; \
+	fi)
+
+id4: id4.py
+	@make clean
+	@echo "---running (wiki) id4.py script"
+	@$(MY_ENV) ./id4.py 1 > id4.out 2>&1   
+	@($(MY_ENV) ./id4.ck; \
+	if [ $$? -eq 0 ]; then \
+	  echo ""; \
+	  echo "GOOD:example_scripts/wiki/id4.py:making variety of principals"; \
+	else \
+	  echo "BAD:example_scripts/wiki/id4.py:making variety of principals"; \
+	fi)
+	rm id4.out
+
+id5: id5.py
+	@make clean
+	@echo "---running (wiki) id5.py script"
+	@$(MY_ENV) ./id5.py 1 > id5.out 2>& 1 
+	@($(MY_ENV) ./id5.ck; \
+	if [ $$? -eq 0 ]; then \
+	  echo ""; \
+	  echo "GOOD:example_scripts/wiki/id5.py:making variety of principals"; \
+	else \
+	  echo "BAD:example_scripts/wiki/id5.py:making variety of principals"; \
+	fi)
+	rm id5.out
+
+attr1: attr1.py
+	@make clean
+	@echo "---running (wiki) attr1.py script"
+	@(rc=`$(MY_ENV) ./attr1.py |wc -c` ; \
+	if [ $$rc -eq 0 ]; then \
+	  echo "GOOD:example_scripts/wiki/attr1.py:making attribute"; \
+	else \
+	  echo "BAD:example_scripts/wiki/attr1.py:making attribute"; \
+	fi)
+
+attr2: attr2.py
+	@make clean
+	@echo "---running (wiki) attr2.py script"
+	@(rc=`$(MY_ENV) ./attr2.py |wc -c` ; \
+	if [ $$rc -eq 0 ]; then \
+	  echo "GOOD:example_scripts/wiki/attr2.py:making more attribute"; \
+	else \
+	  echo "BAD:example_scripts/wiki/attr2.py:making more attribute"; \
+	fi)
+
+ctxtQuery1: ctxtQuery1.py
+	make clean
+	@echo "---running (wiki) ctxtQuery1.py script"
+	@(rc=`$(MY_ENV) ./ctxtQuery1.py |grep "ok? 1"` ; \
+	if [ "$$rc" = "" ]; then \
+	  echo "BAD:example_scripts/wiki/ctxtQuery1.py:prove in context"; \
+	else \
+	  echo "GOOD:example_scripts/wiki/ctxtQuery1.py:prove in context"; \
+	fi)
+
+ctxtQuery2: ctxtQuery2.py
+	make clean
+	@echo "---running (wiki) ctxtQuery2.py script"
+	@(rc=`$(MY_ENV) ./ctxtQuery2.py |grep "ok? 1"` ; \
+	if [ "$$rc" = "" ]; then \
+	  echo "BAD:example_scripts/wiki/ctxtQuery2.py:prove in contxt"; \
+	else \
+	  echo "GOOD:example_scripts/wiki/ctxtQuery2.py:prove in contxt"; \
+	fi)
+
+clean:
+	@rm -rf *.xml *.pem 
+
+clean-local:
+	@rm -rf *.xml *.pem
+
+
Index: tests/example_scripts/wiki/ctxtQuery2.py
===================================================================
--- tests/example_scripts/wiki/ctxtQuery2.py	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/example_scripts/wiki/ctxtQuery2.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,5 +1,5 @@
 #!/usr/bin/env python
 """
-ctxtQuery1.py
+ctxtQuery2.py
 """
 import os
Index: tests/example_scripts/wiki/newguy.sh
===================================================================
--- tests/example_scripts/wiki/newguy.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/example_scripts/wiki/newguy.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,8 @@
+#!/bin/sh
+# newguy.sh
+
+. ${TESTDIR}/test_util.sh
+
+$eloc/creddy --generate --cn newGuy 
+mv newGuy_ID.pem newGuy.pem
+
Index: tests/python_tests/Makefile.am
===================================================================
--- tests/python_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/python_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,69 @@
+#
+# python_tests
+#
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+PYTHON_ENV = PYTHONPATH=$(abs_top_builddir)/swig/python:$(abs_top_builddir)/swig/python/.libs:$(abs_top_builddir)/tests
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(TEST_ENV) $(PYTHON_ENV)
+
+DIRECTORY= acme_rockets_intersection_rt0 acme_rockets_rt0 experiment_create_rt0
+OTHER=basic_attribute basic_id 
+
+.PHONY : clean-local runcheck clean
+all: runcheck
+
+clean :
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  rm -rf *.pem *.xml; \
+	  cd $$here; \
+        done
+	@(cd basic_id; rm -rf *.pem *.xml)
+	@(cd basic_attribute; rm -rf *.pem *.xml)
+	@rm -rf result error
+
+runcheck :
+	@touch error
+	@echo 'running libabac PYTHON testing...' | tee result
+	@make clean
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  printf "\n ==> RUN on %s\n" "$$i" >> $$here/result ; \
+	  $(MY_ENV) ./setup.py 1>/dev/null 2>&1; \
+	  $(MY_ENV) ./attr.py 1>/dev/null 2>&1; \
+	  $(MY_ENV) ./query.py |tee -a $$here/result |grep BAD >> $$here/error; \
+	  cd $$here; \
+        done
+	make ids
+	make attrs
+	@if test -f error ; \
+	  then \
+	    (if test `cat error | wc -l ` -eq 0 ; \
+	      then echo "   PASSED"; \
+	      else (echo "   ERROR!!!"; cat error;) \
+	    fi) \
+	  else echo "   PASSED"; \
+	fi
+
+ids:
+	@printf "\n ==> RUN on basic_id\n" >> result
+	@(cd basic_id; \
+	$(MY_ENV) ./setup.py 1>/dev/null 2>&1; \
+	$(MY_ENV) ./query.py |tee -a ../result |grep BAD >> ../error; \
+	cd ..)
+
+attrs:
+	@printf "\n ==> RUN on basic_attr\n" >> result
+	@(cd basic_attribute; \
+	$(MY_ENV) ./setup.py 1>/dev/null 2>&1; \
+	$(MY_ENV) ./query.py |tee -a ../result |grep BAD >> ../error; \
+	cd ..)
+
+clean-local: 
+	@rm -rf result error
Index: tests/python_tests/acme_rockets_intersection_rt0/query.py
===================================================================
--- tests/python_tests/acme_rockets_intersection_rt0/query.py	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/python_tests/acme_rockets_intersection_rt0/query.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -9,4 +9,5 @@
 import os
 import ABAC
+from test_util import runTest
 
 ctxt = ABAC.Context()
@@ -18,6 +19,6 @@
     ctxt.load_directory(keystore)
 else:
-    print("keystore is not set...")
-    exit(1)
+    print("keystore is not set, using current directory...")
+    ctxt.load_directory(".")
 
 # retrieve principals' keyid value from local credential files
@@ -50,13 +51,6 @@
 # role = "[keyid:Acme].role:buy_rockets"
 # p = "[keyid:coyote]" 
-
-print "\n===good============ Acme.buy_rockets <- Coyote"
-(success, credentials) = ctxt.query("%s.buy_rockets" % acme, coyote)
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
+print "===good============ Acme.buy_rockets <- Coyote"
+runTest("python_tests/acme_rockets_intersection_rt0","test1",ctxt,"%s.buy_rockets" % acme, coyote, 1, "query in python with intersect")
 
 ##########################################################################
@@ -64,11 +58,6 @@
 # role = "[keyid:Acme].role:buy_rockets"
 # p = "[keyid:batman]" 
+print "===bad============ Acme.buy_rockets <- Batman"
+runTest("python_tests/acme_rockets_intersection_rt0","test2",ctxt,"%s.buy_rockets" % acme, batman, 0, "expected failure, no such relation in db")
 
-print "\n===bad============ Acme.buy_rockets <- Batman"
-(success, credentials) = ctxt.query("%s.buy_rockets" % acme, batman)
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
+
Index: tests/python_tests/acme_rockets_rt0/query.py
===================================================================
--- tests/python_tests/acme_rockets_rt0/query.py	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/python_tests/acme_rockets_rt0/query.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -11,4 +11,6 @@
 import ABAC
 
+from test_util import runTest
+
 ctxt = ABAC.Context()
 
@@ -19,6 +21,6 @@
     ctxt.load_directory(keystore)
 else:
-    print("keystore is not set...")
-    exit(1)
+    print("keystore is not set, using current directory...")
+    ctxt.load_directory(".")
 
 # retrieve principals' keyid value from local credential files
@@ -47,13 +49,6 @@
 # role=[keyid:Acme].role:preferred_customer
 # p =[keyid:coyote]
-
-print "\n===good============ Acme.preferred_customer <- Coyote"
-(success, credentials) = ctxt.query("%s.preferred_customer" % acme, coyote)
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
+print "===good============ Acme.preferred_customer <- Coyote"
+runTest("python_tests/acme_rockets_rt0","test1",ctxt,"%s.preferred_customer" % acme, coyote, 1, "simple single rule matchup")
 
 ##########################################################################
@@ -61,13 +56,6 @@
 # role=[keyid:Acme].role:buy_rockets
 # p =[keyid:coyote]
-
-print "\n===good============ Acme.buy_rockets <- Coyote"
-(success, credentials) = ctxt.query("%s.buy_rockets" % acme, coyote)
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
+print "===good============ Acme.buy_rockets <- Coyote"
+runTest("python_tests/acme_rockets_rt0","test2",ctxt,"%s.buy_rockets" % acme, coyote, 1, "very simplequery")
 
 ##########################################################################
@@ -75,13 +63,6 @@
 # role=[keyid:Coyote].role:friend
 # p=[keyid:Acme] 
-
-print "\n===bad=============== Coyote.friend <- Acme"
-(success, credentials) = ctxt.query("%s.friend" % coyote, acme)
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
+print "===bad=============== Coyote.friend <- Acme"
+runTest("python_tests/acme_rockets_rt0","test3",ctxt,"%s.friend" % coyote, acme, 0, "none existing relation")
 
 ##########################################################################
@@ -89,11 +70,5 @@
 # role=[keyid:Acme].role:buy_rockets 
 # p=[keyid:Acme].role:preferred_customer
+print "===bad?=============== Acme.buy_rockets <- Acme.preferred_customer"
+runTest("python_tests/acme_rockets_rt0","test4",ctxt,"%s.buy_rockets" % acme, "%s.preferred_customer" % acme, 1, "complex role query should fail")
 
-print "\n===bad?=============== Acme.buy_rockets <- Acme.preferred_customer"
-(success, credentials) = ctxt.query("%s.buy_rockets" % acme, "%s.preferred_customer" % acme)
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
Index: tests/python_tests/basic_attribute/README
===================================================================
--- tests/python_tests/basic_attribute/README	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/python_tests/basic_attribute/README	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -2,5 +2,5 @@
 # This example demonstrates various ways to create and access
 # ID attribute using libabac api
-#  
+# and use query to show that it is indeed in the db  
 
 case 1: make attribute rule
Index: tests/python_tests/basic_attribute/query.py
===================================================================
--- tests/python_tests/basic_attribute/query.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/python_tests/basic_attribute/query.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,100 @@
+#!/usr/bin/env python
+
+"""
+  to test with python
+
+cmd1:env keystore=`pwd` ./query.py 
+
+"""
+
+import os
+import ABAC
+
+from test_util import runTest
+
+ctxt = ABAC.Context()
+
+def print_a(ctxt, msg, dotdot):
+    print "%s rule set..." % msg
+    credentials = ctxt.credentials()
+    for credential in credentials:
+        print "%s:%s<-%s" % (dotdot,credential.head().string(), credential.tail().string())
+
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+else:
+    print("keystore is not set, using current directory...")
+    ctxt.load_directory(".")
+
+superKID=ABAC.ID("SuperK_ID.pem");
+superKID.load_privkey("SuperK_private.pem");
+ctxt.load_id_chunk(superKID.cert_chunk())
+superK=superKID.keyid()
+
+jackID=ABAC.ID("Jack_ID.pem");
+jackID.load_privkey("Jack_private.pem");
+ctxt.load_id_chunk(jackID.cert_chunk())
+jack=jackID.keyid()
+
+bobID=ABAC.ID("Bob_ID.pem");
+bobID.load_privkey("Bob_private.pem");
+ctxt.load_id_chunk(bobID.cert_chunk())
+bob=bobID.keyid()
+
+maryID=ABAC.ID("Mary_ID.pem");
+maryID.load_privkey("Mary_private.pem");
+ctxt.load_id_chunk(maryID.cert_chunk())
+mary=maryID.keyid()
+
+#case 1:
+#Only employee of SuperK can park
+#[keyid:SuperK].role:park <- [keyid:SuperK].role:employee
+attr = ABAC.Attribute(superKID, "park", 0)
+attr.role(superK,"employee")
+attr.bake()
+attr.write_file("SuperK_park__SuperK_employee_attr.xml")
+ctxt.load_attribute_file("SuperK_park__SuperK_employee_attr.xml")
+print_a(ctxt,"case1","..")
+
+#case 2:
+#Jack is an employee of SuperK
+#[keyid:SuperK].role:employee <- [keyid:Jack]
+attr = ABAC.Attribute(superKID, "employee", 0)
+attr.principal(jack)
+attr.bake()
+# create a policy file at the file system
+attr.write_file("SuperK_employee__Jack_attr.xml")
+ctxt.load_attribute_chunk(attr.cert_chunk());
+print_a(ctxt,"case2","....")
+##########################################################################
+#Jack of SuperK can park?
+print "===good============ SuperK.park <-?- Jack"
+runTest("python_tests/basic_attribute","test1",ctxt,"%s.park" % superK, jack, 1, "check loading of attribute as cert chunk")
+
+#case 3:
+#Bob is an employee of SuperK
+#[keyid:SuperK].role:employee <- [keyid:Bob]
+attr = ABAC.Attribute(superKID, "employee", 0)
+attr.principal(bob)
+attr.bake()
+#chunk=attr.cert_chunk()
+#nattr=ABAC.Attribute_chunk(chunk)
+#ctxt.load_attribute(nattr);
+#print_a(ctxt,"case3", "....")
+
+#case 4:
+#Mary is an employee of SuperK
+#[keyid:SuperK].role:employee <- [keyid:Mary]
+attr = ABAC.Attribute(superKID, "employee", 0)
+attr.principal(mary)
+attr.bake()
+chunk=attr.cert_chunk()
+ctxt.load_attribute_chunk(chunk);
+print_a(ctxt,"case4","......")
+##########################################################################
+#is Mary an employee of superK?
+print "===good============ SuperK.employee <-?- Mary"
+runTest("python_tests/basic_attribute","test2",ctxt,"%s.employee" % superK, mary, 1, "check loading of attribute as chunk")
+
Index: tests/python_tests/basic_id/id_ctxt.py
===================================================================
--- tests/python_tests/basic_id/id_ctxt.py	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/python_tests/basic_id/id_ctxt.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -7,4 +7,5 @@
 cmd:env keystore=`pwd` ./id_ctxt.py 
 
+-- can not run in rt0 yet
 """
 
Index: tests/python_tests/basic_id/query.py
===================================================================
--- tests/python_tests/basic_id/query.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/python_tests/basic_id/query.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,104 @@
+#!/usr/bin/env python
+
+"""
+  to test with python
+
+cmd:env keystore=`pwd` ./query.py 
+
+No real query (originally id.py)
+"""
+
+import os
+import ABAC
+
+ctxt = ABAC.Context()
+
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+#    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set, using current directory...")
+    ctxt.load_directory(".")
+
+## case 1
+## creating and writing out using libabac ID
+id=ABAC.ID("Mary", 0)
+print "adding -> %s(Mary/good)" % id.keyid()
+id.write_cert_file("Mary_ID.pem")
+id.write_privkey_file("Mary_private.pem")
+## load principal with id/key file pair
+## note, with this, we do not have handle on the keyid
+## to Mary but it will be in the db
+#XXX# ctxt.load_id_files("Mary_ID.pem","Mary_private.pem")
+
+## case 2
+## creating principal using ID
+id2=ABAC.ID("Jack2", 0)
+print "adding -> %s(Jack2/good)" % id2.keyid()
+## load principal directly with the ID, no external
+## credential files were created
+#XXX# ctxt.load_id(id2)
+
+## case 3
+## creating principal using ID
+id3=ABAC.ID("Mark", 0)
+print "adding -> %s(Mark/good)" % id3.keyid()
+## write cert and key content to a combo file. One is appended
+## after another
+id3.write_privkey_file("Mark_IDKEY.pem")
+id3.write_cert_file("Mark_IDKEY.pem")
+## load principal in with the combo file with the tandem format
+ctxt.load_id_file("Mark_IDKEY.pem")
+
+## case 4
+## creating principal using ID
+id4=ABAC.ID("John", 0)
+print "adding -> %s(John/good,invisible)" % id4.keyid()
+id4.write_cert_file("John_other.pem")
+## load id without the key file
+ctxt.load_id_file("John_other.pem")
+
+## case 5
+## creating principal using ID
+id5=ABAC.ID("Lori", 0)
+print "adding -> %s(Lori/good,nokey)" % id5.keyid()
+## write just cert into the combo file
+id5.write_cert_file("Lori_IDKEY.pem")
+##load principal from a combo file that only contains cert part
+ctxt.load_id_file("Lori2_IDKEY.pem")
+
+## case 6
+## creating principal using ID
+id6=ABAC.ID("Tom", 0)
+print "adding -> %s(Tom/bad,nocert)" % id6.keyid()
+## write just key into the combo file
+id6.write_privkey_file("Tom_IDKEY.pem")
+## load principal from combo file that only contains key part
+ctxt.load_id_file("Tom_IDKEY.pem")
+
+## case 7
+## creating ID using chunk
+## this already created a Tim with private key and
+## stored in the master list
+id7=ABAC.ID("Tim", 0)
+chunk=id7.cert_chunk() 
+id77=ABAC.ID_chunk(chunk)
+## load principal from new id
+ctxt.load_id_chunk(id77.cert_chunk())
+
+## case 8
+## load directly using chunk
+## this already created a Stanley with private key
+## and stored in the master list
+id8=ABAC.ID("Stanley", 0)
+chunk=id8.cert_chunk() 
+## load principal as chunk
+ctxt.load_id_chunk(chunk)
+
+## case 9
+## failure case, loading a non-existing combo file
+print "adding -> Casper(bad,unknown file)"
+ctxt.load_id_file("Casper_IDKEY.pem")
+
Index: tests/python_tests/experiment_create_rt0/query.py
===================================================================
--- tests/python_tests/experiment_create_rt0/query.py	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/python_tests/experiment_create_rt0/query.py	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -10,4 +10,6 @@
 import ABAC
 
+from test_util import runTest
+
 ctxt = ABAC.Context()
 
@@ -18,6 +20,6 @@
     ctxt.load_directory(keystore)
 else:
-    print("keystore is not set...")
-    exit(1)
+    print("keystore is not set, using current directory...")
+    ctxt.load_directory(".")
 
 # retrieve principals' keyid value from local credential files
@@ -54,14 +56,6 @@
 # role=[keyid:Globotron].role:admin 
 # p=[keyid:Alice]
-
-print "\n===good=============== Globotron.admin <- Alice"
-(success, credentials) = ctxt.query("%s.admin" % globotron, alice)
-
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
+print "===good=============== Globotron.admin <- Alice"
+runTest("python_tests/experiment_create_rt0","test1",ctxt,"%s.admin" % globotron, alice, 1, "query in python")
 
 ##########################################################################
@@ -69,13 +63,6 @@
 # role=[keyid:Globotron].role:admin 
 # p=[keyid:Bob]
-
-print "\n===bad=============== Globotron.admin <- Bob"
-(success, credentials) = ctxt.query("%s.admin" % globotron, bob)
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
+print "===bad=============== Globotron.admin <- Bob"
+runTest("python_tests/experiment_create_rt0","test2",ctxt,"%s.admin" % globotron, bob, 0, "no linking relation")
 
 ##########################################################################
@@ -83,11 +70,5 @@
 # role=[keyid:Acme].role:experiment_create 
 # p=[keyid:Bob]
+print "===good=============== Acme.experiment_create <- Bob"
+runTest("python_tests/experiment_create_rt0","test3",ctxt,"%s.experiment_create" % acme, bob, 1, "query python with inference")
 
-print "\n===good=============== Acme.experiment_create <- Bob"
-(success, credentials) = ctxt.query("%s.experiment_create" % acme, bob)
-if success:
-    print "success!"
-else:
-    print "failure!"
-for credential in credentials:
-    print "credential %s <- %s" % (credential.head().string(), credential.tail().string())
Index: tests/scaling_tests/Makefile.am
===================================================================
--- tests/scaling_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/scaling_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,53 @@
+#
+# scaling_tests
+#
+
+DIRECTORY=daisychain
+#haystack
+PLOT= daisychain/likes_python
+#haystack/fruit_python 
+
+.PHONY : runcheck clean-local plot clean
+
+all:runcheck
+
+local-clean:
+clean:
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  make clean; \
+	  cd $$here; \
+	done; 
+	rm -rf error result
+	rm -rf jpegs
+
+runcheck: 
+	@echo 'running libabac SCALING testing...' | tee result
+	touch error
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  printf "\n ==> RUN on %s\n" "$$i" >> result; \
+	  cd $$i; \
+	  make -s runcheck | tee -a $$here/result |grep BAD >> $$here/error; \
+	  cd $$here; \
+	done; 
+	@if test -f error ; \
+	  then \
+	    (if test `cat error | wc -l ` -eq 0 ; \
+	      then echo "   PASSED"; \
+	      else (echo "   ERROR!!!"; cat error;) \
+	    fi) \
+	  else echo "   PASSED"; \
+	fi
+
+plot:
+	make clean
+	mkdir jpegs
+	@for i in $(PLOT); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  make -s plot; \
+	  cd $$here; \
+	done;
+
Index: tests/scaling_tests/daisychain/Makefile.am
===================================================================
--- tests/scaling_tests/daisychain/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/scaling_tests/daisychain/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,24 @@
+#
+# daisychain
+#
+.PHONY : runcheck clean-local
+
+DIRECTORY=likes_python
+
+all: runcheck
+
+clean-local:
+	@for i in $(DIRECTORY); do \
+	here=`pwd`; \
+	cd $$i; \
+	make clean; \
+	cd $$here;\
+	done;
+
+runcheck: 
+	@for i in $(DIRECTORY); do \
+	here=`pwd`; \
+	cd $$i; \
+	make -s test; \
+	cd $$here;\
+	done;
Index: tests/scaling_tests/daisychain/likes_python/Makefile.am
===================================================================
--- tests/scaling_tests/daisychain/likes_python/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/scaling_tests/daisychain/likes_python/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,42 @@
+#
+# daisychain/likes_python
+#
+.PHONY : test clean-local
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+PYTHON_ENV = PYTHONPATH=$(abs_top_builddir)/swig/python:$(abs_top_builddir)/swig/python/.libs:$(abs_top_builddir)/tests
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(PYTHON_ENV)
+
+TEST=likes_0 likes_10 likes_20
+TIMING=likes_30 likes_40 likes_50 likes_100 likes_150 likes_200
+
+.PHONY : test timing plot 
+
+all: test
+
+test: $(TEST)
+
+timing: $(TIMING)
+
+likes_0 :
+	$(MY_ENV) ./run_one 0
+likes_10 :
+	@$(MY_ENV) ./run_one 10
+likes_20 :
+	@$(MY_ENV) ./run_one 20
+
+clean-local: 
+	@rm -rf likes_* run_plot plot timing
+
+$(TIMING):
+	@$(MY_ENV) ./run_one $(subst likes_,,$@)
+
+plot:
+	@make clean
+	cp ../../plotting/run_plot .
+	@make -s test
+	@make -s timing
+	@./run_plot likes
